diff --git a/src/main/java/net/minecraft/core/block/RedstonePumpkinBlock.java b/src/main/java/net/minecraft/core/block/RedstonePumpkinBlock.java
new file mode 100644
index 000000000..6d64c8580
--- /dev/null
+++ b/src/main/java/net/minecraft/core/block/RedstonePumpkinBlock.java
@@ -0,0 +1,43 @@
+package net.minecraft.core.block;
+
+import net.minecraft.core.block.material.Material;
+import net.minecraft.core.util.helper.Side;
+import net.minecraft.core.world.World;
+import net.minecraft.core.world.WorldSource;
+
+public class RedstonePumpkinBlock extends RotatableBlock {
+
+    public RedstonePumpkinBlock(String translationKey, String namespaceId, int id) {
+        super(translationKey, namespaceId, id, Material.vegetable);
+    }
+
+    @Override
+    public void onBlockPlacedByWorld(World world, int x, int y, int z)
+    {
+        for (Side s : Side.sides){
+            world.notifyBlocksOfNeighborChange(x + s.getOffsetX(), y + s.getOffsetY(), z + s.getOffsetZ(), id);
+        }
+    }
+
+    @Override
+    public void onBlockRemoved(World world, int x, int y, int z, int data)
+    {
+        for (Side s : Side.sides){
+            world.notifyBlocksOfNeighborChange(x + s.getOffsetX(), y + s.getOffsetY(), z + s.getOffsetZ(), id);
+        }
+    }
+
+    @Override
+    public boolean getDirectSignal(World world, int x, int y, int z, Side side) {
+        return getSignal(world, x, y, z, side);
+    }
+
+    @Override
+    public boolean getSignal(WorldSource blockAccess, int x, int y, int z, Side side) {
+        if (!side.isHorizontal()) {
+            return false;
+        }
+        Side mySide = Side.getSideById(blockAccess.getBlockMetadata(x, y, z));
+        return mySide == side.getOpposite();
+    }
+}
diff --git a/src/main/java/net/minecraft/core/block/BlockRedstoneTorch.java b/src/main/java/net/minecraft/core/block/RedstoneTorchBlock.java
similarity index 67%
rename from src/main/java/net/minecraft/core/block/BlockRedstoneTorch.java
rename to src/main/java/net/minecraft/core/block/RedstoneTorchBlock.java
index 08eeceed7..bcaf06c8d 100644
--- a/src/main/java/net/minecraft/core/block/BlockRedstoneTorch.java
+++ b/src/main/java/net/minecraft/core/block/RedstoneTorchBlock.java
@@ -1,12 +1,13 @@
 package net.minecraft.core.block;
 
 import net.minecraft.client.util.helper.Colors;
-import net.minecraft.core.block.entity.TileEntity;
+import net.minecraft.core.block.entity.BlockEntity;
 import net.minecraft.core.block.logic.RedstoneUpdateInfo;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.sound.SoundCategory;
 import net.minecraft.core.util.helper.Color;
+import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.WorldSource;
 
@@ -15,20 +16,19 @@ import java.util.List;
 import java.util.Random;
 
 // Referenced classes of package net.minecraft.src:
-//            BlockTorch, Block, RedstoneUpdateInfo, World, 
+//            TorchBlock, Block, RedstoneUpdateInfo, World,
 //            IBlockAccess
 
-public class BlockRedstoneTorch extends BlockTorch
+public class RedstoneTorchBlock extends TorchBlock
 {
-    private boolean checkForBurnout(World world, int i, int j, int k, boolean flag)
+    private boolean checkForBurnout(World world, int x, int y, int z, boolean addUpdateInfo)
     {
-        if(flag)
-        {
-            torchUpdates.add(new RedstoneUpdateInfo(i, j, k, world.getWorldTime()));
+        if(addUpdateInfo) {
+            torchUpdates.add(new RedstoneUpdateInfo(x, y, z, world.getWorldTime()));
         }
         int l = 0;
         for (RedstoneUpdateInfo redstoneupdateinfo : torchUpdates) {
-            if (redstoneupdateinfo.getXCoord() == i && redstoneupdateinfo.getYCoord() == j && redstoneupdateinfo.getZCoord() == k && ++l >= 8) {
+            if (redstoneupdateinfo.getXCoord() == x && redstoneupdateinfo.getYCoord() == y && redstoneupdateinfo.getZCoord() == z && ++l >= 8) {
                 return true;
             }
         }
@@ -36,28 +36,25 @@ public class BlockRedstoneTorch extends BlockTorch
         return false;
     }
 
-    protected BlockRedstoneTorch(String key, int id, boolean flag)
-    {
-        super(key, id);
+    protected RedstoneTorchBlock(String key, String namespaceId, int id, boolean flag) {
+        super(key, namespaceId, id);
         torchActive = flag;
         setTicking(true);
     }
 
     @Override
-    public int tickRate()
+    public int tickDelay()
     {
         return 2;
     }
 
     @Override
-	public void onBlockAdded(World world, int x, int y, int z)
+	public void onBlockPlacedByWorld(World world, int x, int y, int z)
     {
-        if(world.getBlockMetadata(x, y, z) == 0)
-        {
-            super.onBlockAdded(world, x, y, z);
+        if(world.getBlockMetadata(x, y, z) == 0) {
+            super.onBlockPlacedByWorld(world, x, y, z);
         }
-        if(torchActive)
-        {
+        if(torchActive) {
             world.notifyBlocksOfNeighborChange(x, y - 1, z, id);
             world.notifyBlocksOfNeighborChange(x, y + 1, z, id);
             world.notifyBlocksOfNeighborChange(x - 1, y, z, id);
@@ -68,10 +65,8 @@ public class BlockRedstoneTorch extends BlockTorch
     }
 
     @Override
-    public void onBlockRemoved(World world, int x, int y, int z, int data)
-    {
-        if(torchActive)
-        {
+    public void onBlockRemoved(World world, int x, int y, int z, int data) {
+        if(torchActive) {
             world.notifyBlocksOfNeighborChange(x, y - 1, z, id);
             world.notifyBlocksOfNeighborChange(x, y + 1, z, id);
             world.notifyBlocksOfNeighborChange(x - 1, y, z, id);
@@ -82,52 +77,41 @@ public class BlockRedstoneTorch extends BlockTorch
     }
 
     @Override
-    public boolean isPoweringTo(WorldSource blockAccess, int x, int y, int z, int side)
-    {
-        if(!torchActive)
-        {
+    public boolean getSignal(WorldSource blockAccess, int x, int y, int z, Side side) {
+        if(!torchActive) {
             return false;
         }
-        int i1 = blockAccess.getBlockMetadata(x, y, z);
-        if(i1 == 5 && side == 1)
-        {
+        int meta = blockAccess.getBlockMetadata(x, y, z);
+        if(meta == 5 && side == Side.TOP) {
             return false;
         }
-        if(i1 == 3 && side == 3)
-        {
+        if(meta == 3 && side == Side.SOUTH) {
             return false;
         }
-        if(i1 == 4 && side == 2)
-        {
+        if(meta == 4 && side == Side.NORTH) {
             return false;
         }
-        if(i1 == 1 && side == 5)
-        {
+        if(meta == 1 && side == Side.EAST) {
             return false;
         }
-        return i1 != 2 || side != 4;
+        return meta != 2 || side != Side.WEST;
     }
 
-    private boolean isPoweredByBlock(World world, int i, int j, int k)
-    {
-        int l = world.getBlockMetadata(i, j, k);
-        if(l == 5 && world.isBlockIndirectlyProvidingPowerTo(i, j - 1, k, 0))
-        {
+    private boolean isPoweredByBlock(World world, int x, int y, int z) {
+        int meta = world.getBlockMetadata(x, y, z);
+        if(meta == 5 && world.isBlockIndirectlyProvidingPowerTo(x, y - 1, z, Side.BOTTOM)) {
             return true;
         }
-        if(l == 3 && world.isBlockIndirectlyProvidingPowerTo(i, j, k - 1, 2))
-        {
+        if(meta == 3 && world.isBlockIndirectlyProvidingPowerTo(x, y, z - 1, Side.NORTH)) {
             return true;
         }
-        if(l == 4 && world.isBlockIndirectlyProvidingPowerTo(i, j, k + 1, 3))
-        {
+        if(meta == 4 && world.isBlockIndirectlyProvidingPowerTo(x, y, z + 1, Side.SOUTH)) {
             return true;
         }
-        if(l == 1 && world.isBlockIndirectlyProvidingPowerTo(i - 1, j, k, 4))
-        {
+        if(meta == 1 && world.isBlockIndirectlyProvidingPowerTo(x - 1, y, z, Side.WEST)) {
             return true;
         }
-        return l == 2 && world.isBlockIndirectlyProvidingPowerTo(i + 1, j, k, 5);
+        return meta == 2 && world.isBlockIndirectlyProvidingPowerTo(x + 1, y, z, Side.EAST);
     }
 
     @Override
@@ -145,7 +129,7 @@ public class BlockRedstoneTorch extends BlockTorch
         {
             if(flag)
             {
-                world.setBlockAndMetadataWithNotify(x, y, z, Block.torchRedstoneIdle.id, world.getBlockMetadata(x, y, z));
+                world.setBlockAndMetadataWithNotify(x, y, z, Blocks.TORCH_REDSTONE_IDLE.id, world.getBlockMetadata(x, y, z));
                 if(checkForBurnout(world, x, y, z, true))
                 {
                     world.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, (float) x + 0.5F, (float) y + 0.5F, (float) z + 0.5F, "random.fizz", 0.5F, 2.6F + (world.rand.nextFloat() - world.rand.nextFloat()) * 0.8F);
@@ -161,7 +145,7 @@ public class BlockRedstoneTorch extends BlockTorch
         } else
         if(!flag && !checkForBurnout(world, x, y, z, false))
         {
-            world.setBlockAndMetadataWithNotify(x, y, z, Block.torchRedstoneActive.id, world.getBlockMetadata(x, y, z));
+            world.setBlockAndMetadataWithNotify(x, y, z, Blocks.TORCH_REDSTONE_ACTIVE.id, world.getBlockMetadata(x, y, z));
         }
     }
 
@@ -169,35 +153,32 @@ public class BlockRedstoneTorch extends BlockTorch
 	public void onNeighborBlockChange(World world, int x, int y, int z, int blockId)
     {
         super.onNeighborBlockChange(world, x, y, z, blockId);
-        world.scheduleBlockUpdate(x, y, z, id, tickRate());
+        world.scheduleBlockUpdate(x, y, z, id, tickDelay());
     }
 
     @Override
-    public boolean isIndirectlyPoweringTo(World world, int x, int y, int z, int side)
+    public boolean getDirectSignal(World world, int x, int y, int z, Side side)
     {
-        if(side == 0)
-        {
-            return isPoweringTo(world, x, y, z, side);
-        } else
-        {
+        if(side == Side.BOTTOM) {
+            return getSignal(world, x, y, z, side);
+        } else {
             return false;
         }
     }
 
     @Override
-    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int x, int y, int z, int meta, TileEntity tileEntity)
-    {
-        return new ItemStack[] { new ItemStack(Block.torchRedstoneActive) };
+    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int x, int y, int z, int meta, BlockEntity blockEntity) {
+        return new ItemStack[] { new ItemStack(Blocks.TORCH_REDSTONE_ACTIVE) };
     }
 
     @Override
-    public boolean canProvidePower()
+    public boolean isSignalSource()
     {
         return true;
     }
 
     @Override
-	public void randomDisplayTick(World world, int x, int y, int z, Random rand) {
+	public void animationTick(World world, int x, int y, int z, Random rand) {
 		if (!torchActive) {
 			return;
 		}
diff --git a/src/main/java/net/minecraft/core/block/BlockRedstoneWire.java b/src/main/java/net/minecraft/core/block/RedstoneWireBlock.java
similarity index 64%
rename from src/main/java/net/minecraft/core/block/BlockRedstoneWire.java
rename to src/main/java/net/minecraft/core/block/RedstoneWireBlock.java
index 7ed042869..7ea6f59ae 100644
--- a/src/main/java/net/minecraft/core/block/BlockRedstoneWire.java
+++ b/src/main/java/net/minecraft/core/block/RedstoneWireBlock.java
@@ -1,10 +1,11 @@
 package net.minecraft.core.block;
 
-import net.minecraft.core.block.entity.TileEntity;
+import net.minecraft.core.block.entity.BlockEntity;
 import net.minecraft.core.enums.EnumDropCause;
-import net.minecraft.core.item.Item;
 import net.minecraft.core.item.ItemStack;
-import net.minecraft.core.block.logic.BedDirections;
+import net.minecraft.core.item.Items;
+import net.minecraft.core.util.helper.Axis;
+import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.WorldSource;
 import net.minecraft.core.world.World;
 import net.minecraft.core.block.material.Material;
@@ -19,14 +20,14 @@ import java.util.*;
 //            Block, Material, World, ChunkPosition, 
 //            Item, IBlockAccess, ModelBed, AxisAlignedBB
 
-public class BlockRedstoneWire extends Block
+public class RedstoneWireBlock extends Block
 {
 
-    public BlockRedstoneWire(String key, int id)
+    public RedstoneWireBlock(String key, String namespaceId, int id)
     {
-        super(key, id, Material.decoration);
+        super(key, namespaceId, id, Material.decoration);
         wiresProvidePower = true;
-        field_21031_b = new HashSet();
+        chunkPositionSet = new HashSet<>();
         setBlockBounds(0.0F, 0.0F, 0.0F, 1.0F, 0.0625F, 1.0F);
     }
 
@@ -43,7 +44,7 @@ public class BlockRedstoneWire extends Block
     }
 
     @Override
-	public boolean renderAsNormalBlock()
+	public boolean isCubeShaped()
     {
         return false;
     }
@@ -54,35 +55,30 @@ public class BlockRedstoneWire extends Block
         return world.canPlaceOnSurfaceOfBlock(x, y - 1, z);
     }
 
-    private void updateAndPropagateCurrentStrength(World world, int i, int j, int k)
+    private void updateAndPropagateCurrentStrength(World world, int x, int y, int z)
     {
-        func_21030_a(world, i, j, k, i, j, k);
-        ArrayList arraylist = new ArrayList(field_21031_b);
-        field_21031_b.clear();
-        for(int l = 0; l < arraylist.size(); l++)
-        {
-            ChunkPosition chunkposition = (ChunkPosition)arraylist.get(l);
+        func_21030_a(world, x, y, z, x, y, z);
+        ArrayList<ChunkPosition> arraylist = new ArrayList<>(chunkPositionSet);
+        chunkPositionSet.clear();
+        for (ChunkPosition chunkposition : arraylist) {
             world.notifyBlocksOfNeighborChange(chunkposition.x, chunkposition.y, chunkposition.z, id);
         }
 
     }
 
-    private void func_21030_a(World world, int i, int j, int k, int l, int i1, int j1)
-    {
-        int k1 = world.getBlockMetadata(i, j, k);
+    private void func_21030_a(World world, int x, int y, int z, int l, int i1, int j1) {
+        int meta = world.getBlockMetadata(x, y, z);
         int l1 = 0;
         wiresProvidePower = false;
-        boolean flag = world.isBlockIndirectlyGettingPowered(i, j, k);
+        boolean flag = world.isBlockIndirectlyGettingPowered(x, y, z);
         wiresProvidePower = true;
-        if(flag)
-        {
+        if(flag) {
             l1 = 15;
-        } else
-        {
+        } else {
             for(int i2 = 0; i2 < 4; i2++)
             {
-                int k2 = i;
-                int i3 = k;
+                int k2 = x;
+                int i3 = z;
                 if(i2 == 0)
                 {
                     k2--;
@@ -99,21 +95,21 @@ public class BlockRedstoneWire extends Block
                 {
                     i3++;
                 }
-                if(k2 != l || j != i1 || i3 != j1)
+                if(k2 != l || y != i1 || i3 != j1)
                 {
-                    l1 = getMaxCurrentStrength(world, k2, j, i3, l1);
+                    l1 = getMaxCurrentStrength(world, k2, y, i3, l1);
                 }
-                if(world.isBlockNormalCube(k2, j, i3) && !world.isBlockNormalCube(i, j + 1, k))
+                if(world.isBlockNormalCube(k2, y, i3) && !world.isBlockNormalCube(x, y + 1, z))
                 {
-                    if(k2 != l || j + 1 != i1 || i3 != j1)
+                    if(k2 != l || y + 1 != i1 || i3 != j1)
                     {
-                        l1 = getMaxCurrentStrength(world, k2, j + 1, i3, l1);
+                        l1 = getMaxCurrentStrength(world, k2, y + 1, i3, l1);
                     }
                     continue;
                 }
-                if(!world.isBlockNormalCube(k2, j, i3) && (k2 != l || j - 1 != i1 || i3 != j1))
+                if(!world.isBlockNormalCube(k2, y, i3) && (k2 != l || y - 1 != i1 || i3 != j1))
                 {
-                    l1 = getMaxCurrentStrength(world, k2, j - 1, i3, l1);
+                    l1 = getMaxCurrentStrength(world, k2, y - 1, i3, l1);
                 }
             }
 
@@ -125,17 +121,17 @@ public class BlockRedstoneWire extends Block
                 l1 = 0;
             }
         }
-        if(k1 != l1)
+        if(meta != l1)
         {
             world.editingBlocks = true;
-            world.setBlockMetadataWithNotify(i, j, k, l1);
-            world.markBlocksDirty(i, j, k, i, j, k);
+            world.setBlockMetadataWithNotify(x, y, z, l1);
+            world.markBlocksDirty(x, y, z, x, y, z);
             world.editingBlocks = false;
             for(int j2 = 0; j2 < 4; j2++)
             {
-                int l2 = i;
-                int j3 = k;
-                int k3 = j - 1;
+                int l2 = x;
+                int j3 = z;
+                int k3 = y - 1;
                 if(j2 == 0)
                 {
                     l2--;
@@ -152,68 +148,63 @@ public class BlockRedstoneWire extends Block
                 {
                     j3++;
                 }
-                if(world.isBlockNormalCube(l2, j, j3))
+                if(world.isBlockNormalCube(l2, y, j3))
                 {
                     k3 += 2;
                 }
                 int l3 = 0;
-                l3 = getMaxCurrentStrength(world, l2, j, j3, -1);
-                l1 = world.getBlockMetadata(i, j, k);
+                l3 = getMaxCurrentStrength(world, l2, y, j3, -1);
+                l1 = world.getBlockMetadata(x, y, z);
                 if(l1 > 0)
                 {
                     l1--;
                 }
                 if(l3 >= 0 && l3 != l1)
                 {
-                    func_21030_a(world, l2, j, j3, i, j, k);
+                    func_21030_a(world, l2, y, j3, x, y, z);
                 }
                 l3 = getMaxCurrentStrength(world, l2, k3, j3, -1);
-                l1 = world.getBlockMetadata(i, j, k);
+                l1 = world.getBlockMetadata(x, y, z);
                 if(l1 > 0)
                 {
                     l1--;
                 }
                 if(l3 >= 0 && l3 != l1)
                 {
-                    func_21030_a(world, l2, k3, j3, i, j, k);
+                    func_21030_a(world, l2, k3, j3, x, y, z);
                 }
             }
 
-            if(k1 == 0 || l1 == 0)
+            if(meta == 0 || l1 == 0)
             {
-                field_21031_b.add(new ChunkPosition(i, j, k));
-                field_21031_b.add(new ChunkPosition(i - 1, j, k));
-                field_21031_b.add(new ChunkPosition(i + 1, j, k));
-                field_21031_b.add(new ChunkPosition(i, j - 1, k));
-                field_21031_b.add(new ChunkPosition(i, j + 1, k));
-                field_21031_b.add(new ChunkPosition(i, j, k - 1));
-                field_21031_b.add(new ChunkPosition(i, j, k + 1));
+                chunkPositionSet.add(new ChunkPosition(x, y, z));
+                chunkPositionSet.add(new ChunkPosition(x - 1, y, z));
+                chunkPositionSet.add(new ChunkPosition(x + 1, y, z));
+                chunkPositionSet.add(new ChunkPosition(x, y - 1, z));
+                chunkPositionSet.add(new ChunkPosition(x, y + 1, z));
+                chunkPositionSet.add(new ChunkPosition(x, y, z - 1));
+                chunkPositionSet.add(new ChunkPosition(x, y, z + 1));
             }
         }
     }
 
-    private void notifyWireNeighborsOfNeighborChange(World world, int i, int j, int k)
+    private void notifyWireNeighborsOfNeighborChange(World world, int x, int y, int z)
     {
-        if(world.getBlockId(i, j, k) != id)
-        {
-            return;
-        } else
-        {
-            world.notifyBlocksOfNeighborChange(i, j, k, id);
-            world.notifyBlocksOfNeighborChange(i - 1, j, k, id);
-            world.notifyBlocksOfNeighborChange(i + 1, j, k, id);
-            world.notifyBlocksOfNeighborChange(i, j, k - 1, id);
-            world.notifyBlocksOfNeighborChange(i, j, k + 1, id);
-            world.notifyBlocksOfNeighborChange(i, j - 1, k, id);
-            world.notifyBlocksOfNeighborChange(i, j + 1, k, id);
-            return;
+        if (world.getBlockId(x, y, z) == id) {
+            world.notifyBlocksOfNeighborChange(x, y, z, id);
+            world.notifyBlocksOfNeighborChange(x - 1, y, z, id);
+            world.notifyBlocksOfNeighborChange(x + 1, y, z, id);
+            world.notifyBlocksOfNeighborChange(x, y, z - 1, id);
+            world.notifyBlocksOfNeighborChange(x, y, z + 1, id);
+            world.notifyBlocksOfNeighborChange(x, y - 1, z, id);
+            world.notifyBlocksOfNeighborChange(x, y + 1, z, id);
         }
     }
 
     @Override
-	public void onBlockAdded(World world, int x, int y, int z)
+	public void onBlockPlacedByWorld(World world, int x, int y, int z)
     {
-        super.onBlockAdded(world, x, y, z);
+        super.onBlockPlacedByWorld(world, x, y, z);
         if(world.isClientSide)
         {
             return;
@@ -300,73 +291,55 @@ public class BlockRedstoneWire extends Block
         }
     }
 
-    private int getMaxCurrentStrength(World world, int i, int j, int k, int l)
-    {
-        if(world.getBlockId(i, j, k) != id)
-        {
-            return l;
-        }
-        int i1 = world.getBlockMetadata(i, j, k);
-        if(i1 > l)
-        {
-            return i1;
-        } else
-        {
-            return l;
+    private int getMaxCurrentStrength(World world, int x, int y, int z, int inputMeta) {
+        if(world.getBlockId(x, y, z) != id) {
+            return inputMeta;
         }
+
+        int meta = world.getBlockMetadata(x, y, z);
+        return Math.max(meta, inputMeta);
     }
 
     @Override
-	public void onNeighborBlockChange(World world, int x, int y, int z, int blockId)
-    {
-        if(world.isClientSide)
-        {
-            return;
-        }
-        int i1 = world.getBlockMetadata(x, y, z);
+	public void onNeighborBlockChange(World world, int x, int y, int z, int blockId) {
+        if(world.isClientSide) {return;}
+
+        int meta = world.getBlockMetadata(x, y, z);
         boolean flag = canPlaceBlockAt(world, x, y, z);
-        if(!flag)
-        {
-            dropBlockWithCause(world, EnumDropCause.WORLD, x, y, z, i1, null);
+        if(!flag) {
+            dropBlockWithCause(world, EnumDropCause.WORLD, x, y, z, meta, null);
             world.setBlockWithNotify(x, y, z, 0);
-        } else
-        {
+        } else {
             updateAndPropagateCurrentStrength(world, x, y, z);
         }
         super.onNeighborBlockChange(world, x, y, z, blockId);
     }
 
     @Override
-    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int x, int y, int z, int meta, TileEntity tileEntity)
-    {
-        return new ItemStack[] { new ItemStack(Item.dustRedstone ) };
+    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int x, int y, int z, int meta, BlockEntity blockEntity) {
+        return new ItemStack[] { new ItemStack(Items.DUST_REDSTONE ) };
     }
 
     @Override
-    public boolean isIndirectlyPoweringTo(World world, int x, int y, int z, int side)
+    public boolean getDirectSignal(World world, int x, int y, int z, Side side)
     {
-        if(!wiresProvidePower)
-        {
+        if(!wiresProvidePower) {
             return false;
-        } else
-        {
-            return isPoweringTo(world, x, y, z, side);
+        } else {
+            return getSignal(world, x, y, z, side);
         }
     }
 
     @Override
-    public boolean isPoweringTo(WorldSource blockAccess, int x, int y, int z, int side)
+    public boolean getSignal(WorldSource blockAccess, int x, int y, int z, Side side)
     {
-        if(!wiresProvidePower)
-        {
+        if(!wiresProvidePower) {
             return false;
         }
-        if(blockAccess.getBlockMetadata(x, y, z) == 0)
-        {
+        if(blockAccess.getBlockMetadata(x, y, z) == 0) {
             return false;
         }
-        if(side == 1)
-        {
+        if(side == Side.TOP) {
             return true;
         }
         boolean flag = isPowerProviderOrWire(blockAccess, x - 1, y, z, 1) || !blockAccess.isBlockNormalCube(x - 1, y, z) && isPowerProviderOrWire(blockAccess, x - 1, y - 1, z, -1);
@@ -392,33 +365,33 @@ public class BlockRedstoneWire extends Block
                 flag3 = true;
             }
         }
-        if(!flag2 && !flag1 && !flag && !flag3 && side >= 2 && side <= 5)
+        if(!flag2 && !flag1 && !flag && !flag3 && side.getAxis() != Axis.Y)
         {
             return true;
         }
-        if(side == 2 && flag2 && !flag && !flag1)
+        if(side == Side.NORTH && flag2 && !flag && !flag1)
         {
             return true;
         }
-        if(side == 3 && flag3 && !flag && !flag1)
+        if(side == Side.SOUTH && flag3 && !flag && !flag1)
         {
             return true;
         }
-        if(side == 4 && flag && !flag2 && !flag3)
+        if(side == Side.WEST && flag && !flag2 && !flag3)
         {
             return true;
         }
-        return side == 5 && flag1 && !flag2 && !flag3;
+        return side == Side.EAST && flag1 && !flag2 && !flag3;
     }
 
     @Override
-    public boolean canProvidePower()
+    public boolean isSignalSource()
     {
         return wiresProvidePower;
     }
 
 	@Override
-	public void randomDisplayTick(World world, int x, int y, int z, Random rand) {
+	public void animationTick(World world, int x, int y, int z, Random rand) {
 		int meta = world.getBlockMetadata(x, y, z);
 		if(meta == 0) {
 			return;
@@ -439,31 +412,34 @@ public class BlockRedstoneWire extends Block
 		world.spawnParticle("reddust", px, py, pz, red, green, blue, redstoneBrightness);
 	}
 
-    public static boolean isPowerProviderOrWire(WorldSource iblockaccess, int i, int j, int k, int l)
+    public static boolean isPowerProviderOrWire(WorldSource worldSource, int x, int y, int z, int l)
     {
-        int i1 = iblockaccess.getBlockId(i, j, k);
-        if(i1 == Block.wireRedstone.id)
-        {
+        int blockId = worldSource.getBlockId(x, y, z);
+        if(blockId == Blocks.WIRE_REDSTONE.id) {
             return true;
         }
-        if(i1 == 0)
-        {
+        if(blockId <= 0) {
             return false;
         }
-        if(Block.blocksList[i1].canProvidePower())
-        {
+        if(Block.blocksList[blockId].isSignalSource()) {
             return true;
         }
-        if(i1 == Block.repeaterIdle.id || i1 == Block.repeaterActive.id)
-        {
-            int j1 = iblockaccess.getBlockMetadata(i, j, k);
-            return l == BedDirections.footToHeadMap[j1 & 3];
-        } else
-        {
+        if (blockId == Blocks.PUMPKIN_REDSTONE.id) {
+            if (l < 0 || l > 3) {
+                return false;
+            }
+            Side[] lookup = { Side.NORTH, Side.EAST, Side.SOUTH, Side.WEST };
+            Side side = Side.getSideById(worldSource.getBlockMetadata(x, y, z));
+            return side == lookup[l];
+        }
+        if(blockId == Blocks.REPEATER_IDLE.id || blockId == Blocks.REPEATER_ACTIVE.id) {
+            int meta = worldSource.getBlockMetadata(x, y, z);
+            return l == BedBlock.footToHeadMap[meta & 0b11];
+        } else {
             return false;
         }
     }
 
     private boolean wiresProvidePower;
-    private Set field_21031_b;
+    private final Set<ChunkPosition> chunkPositionSet;
 }
